searchNodes=[{"ref":"Mix.Tasks.Compile.Netler.html","title":"Mix.Tasks.Compile.Netler","type":"task","doc":"Compiles all embedded .NET projects listed in dotnet_projects in mix.exs. Usage In mix.exs: def project do [ app: :my_elixir_application, version: &quot;0.1.0&quot;, elixir: &quot;~&gt; 1.9&quot;, start_permanent: Mix.env() == :prod, deps: deps(), compilers: Mix.compilers() ++ [:netler], dotnet_projects: [:my_dotnet_project] ] end"},{"ref":"Mix.Tasks.Netler.New.html","title":"Mix.Tasks.Netler.New","type":"task","doc":"Creates a new embedded .NET project and an Elixir module for communicating with the .NET project Usage &gt; mix netler.new"},{"ref":"Netler.html","title":"Netler","type":"module","doc":"API module for interop with embedded .NET projects Usage defmodule MyElixirApplication.MyDotnetProject do # This links a module to a specific .NET project use Netler, dotnet_project: :my_dotnet_project # Use invoke/2 or invoke!/2 to route a message to # an exported .NET method def add(a, b), do: invoke(&quot;Add&quot;, [a, b]) end"},{"ref":"readme.html","title":"Netler","type":"extras","doc":"Netler Enables language interopablility between Elixir and .NET. Heavily inspired by Rustlers convenience."},{"ref":"readme.html#getting-started","title":"Netler - Getting Started","type":"extras","doc":"1. Add Netler to Your Dependencies defp deps do [ {:netler, &quot;~&gt; 0.1.0&quot;} ] end 2. Run a Mix Task to Generate .NET Project and Elixir Module &gt; mix netler.new You will be asked to give the project a name. This name will be used for both the .NET project and the Elixir module. Here&#39;s an example of the output: Please give your .NET project a name: my_dotnet_project Created ./dotnet/my_dotnet_project/MyDotnetProject.csproj Created ./dotnet/my_dotnet_project/Program.cs Created ./lib/&lt;elixir project&gt;/my_dotnet_project.ex Microsoft (R) Build Engine Copyright (C) Microsoft Corporation. All rights reserved. Restore completed in 355.64 ms Build succeeded. 0 Warning(s) 0 Error(s) Time Elapsed 00:00:08.74 Done! Remeber to add :my_dotnet_project to the dotnet_projects list in your application&#39;s mix.exs 3. Add Netler Compiler and .NET Project to mix.exs Netler will automatically compile the .NET projects when you run mix compile, but you need to wire up the compiler in your mix.exs file. You must also specify which .NET projects that should be compiled and started together with the Elixir application. def project do [ app: :my_elixir_application, version: &quot;0.1.0&quot;, elixir: &quot;~&gt; 1.9&quot;, start_permanent: Mix.env() == :prod, deps: deps(), compilers: Mix.compilers() ++ [:netler], dotnet_projects: [:my_dotnet_project] ] end 4. Compile and Start your Elixir Application &gt; iex -S mix You should now see how the Netler compiler starts MSBuild to compile your embedded .NET project. When the compilation is completed you should be able to call the Elixir module that was created by mix netler.new like this: iex(1)&gt; MyElixirApplication.MyDotnetProject.add(2, 5) {:ok, 7}"},{"ref":"readme.html#the-project-structure","title":"Netler - The Project Structure","type":"extras","doc":"Embedded .NET Projects .NET projects created with mix netler.new are stored in a folder called dotnet in the root of your Elixir project. You will find a &lt;project_name&gt;.csproj file and a Program.cs file, which is the entrypoint. This is what the generated Program.cs looks like: using System; using System.Collections.Generic; using Netler; namespace MyDotnetProject { class Program { static void Main(string[] args) { Netler.Server.Export( args, new Dictionary&lt;string, Func&lt;object[], object&gt;&gt; { {&quot;Add&quot;, Add} // You can export more methods here... } ); } // This is the code that gets executed when // the function `add/2` is called from Elixir static object Add(params object[] parameters) { var a = Convert.ToInt32(parameters[0]); var b = Convert.ToInt32(parameters[1]); return a + b; } } } Elixir Modules for Calling the Embedded .NET Projects mix netler.new also creates an Elixir module that corresponds to the embedded .NET project that was created. The module is your API for interop with .NET. defmodule MyElixirApplication.MyDotnetProject do # This links the module to a specific .NET project use Netler, dotnet_project: :my_dotnet_project # Use invoke/2 or invoke!/2 to route a message to # an exported .NET method def add(a, b), do: invoke(&quot;Add&quot;, [a, b]) end"},{"ref":"readme.html#known-issues","title":"Netler - Known Issues","type":"extras","doc":"Error handling is still WIP. It should probably follow a fault tolerant patter and give the possibility to get debug information from the .NET process. Messages are sent and received using the MessagePack binary format. There are both data type and size limitations when serializing terms. I&#39;m considering switching to BSON but more field testing is required before making the jump."}]